---------------------
-- Variables
---------------------

_DamageCounter = {}
local DGC = _DamageCounter

local Default_Settings = {
	roles = {},
	icons = {},
	x = 500, y = 500, docked = "Y",
	icon_x = 0, icon_y = 0
}

local frWidth = {
	a = 0,
	c = 0,
	cc= 0,
	t = 0,
	cd= 0,
	nd= 0
}

local hdrHeight = 0
local ttlHeight = 0

DGC.context = UI.CreateContext("DGC")
DGC.Frame = UI.CreateFrame("Frame", "DGC.Frame", DGC.context)
DGC.Frame:SetBackgroundColor(0,0,0,0.25)
DGC.Frame:SetVisible(true)

DGC.abFrames = {}

local role_needed = true
local tx_lastupdate = 0
local tx_firstrun = 0
local txtUpdateNeeded = false
local abFrameUpdateNeeded = false
local buildUINeeded = false
local abFrameOrderNeeded = false
local abList = {}
local visFrames = {}
local curRole = 0
local abTxtChanges = {}
local UIbuilt = false
local playerID = Inspect.Unit.Lookup("player")
local coroDead = false

---------------------
-- Functions
---------------------

local function MergeTable(o,n)
	for k,v in pairs(n) do
		if type(v) == "table" then
			if o[k] == nil then
				o[k] = {}				
			end
	 	 	if type(o[k]) == 'table' then
	 			MergeTable(o[k], n[k])
	 	 	end
		else
			if o[k] == nil then
				o[k] = v
			end
		end
	end
end

function DGC.SVLoaded(a)
	if a == "DamageCounter" then
--	print("SVLoaded()")
		if DamageCounter_Settings == nil then
			DamageCounter_Settings = {}
		end
		MergeTable(DamageCounter_Settings, Default_Settings)
		DGC.Frame:SetPoint("TOPLEFT", UIParent, "TOPLEFT", DamageCounter_Settings.x,DamageCounter_Settings.y)
		for r,_ in pairs(DamageCounter_Settings.roles) do
			for k,v in pairs(DamageCounter_Settings.roles[r].abilities) do
				abList[k] = true
			end
		end
		table.insert(Event.Combat.Damage, { DGC.CombatDmg, "DamageCounter", "Event.Combat.Damage"})
		buildUINeeded = true
		abFrameUpdateNeeded = true
	end
end

function DGC.AddonLoaded(a)
	if a == "DamageCounter" then
		local dx = Inspect.Addon.Detail(a)
		print("v"..dx.toc.Version.." loaded.")
	end
end

function DGC.frameUpdate()
--	print("S:frameUpdate()")
	local frcnt = 0
	for k,_ in pairs(abList) do
		if DGC.abFrames[k] == nil then
			frcnt=frcnt+1
			local curFrame = {}
			
			curFrame.abName = UI.CreateFrame("Text", "abName", DGC.Frame)
			curFrame.abName:SetText(k)
			local frw = curFrame.abName:GetWidth()
			if frw > frWidth.a then
				frWidth.a = frw
			end
			curFrame.icon = UI.CreateFrame("Texture", "icon", curFrame.abName)
			curFrame.icon:SetPoint("TOPRIGHT", curFrame.abName, "TOPLEFT")
			curFrame.icon:SetHeight(hdrHeight)
			curFrame.icon:SetWidth(hdrHeight)
			function curFrame.icon.Event:RightClick()
				local abName = k
				local abDtl = DamageCounter_Settings.roles[curRole].abilities[abName] or { cnt=0, dmg=0 }
				DamageCounter_Settings.roles[curRole].count = DamageCounter_Settings.roles[curRole].count-(abDtl.cnt or 0)
				DamageCounter_Settings.roles[curRole].total = DamageCounter_Settings.roles[curRole].total-(abDtl.dmg or 0)
				DamageCounter_Settings.roles[curRole].abilities[abName] = nil
				abFrameOrderNeeded = true
			end
			curFrame.cnt = UI.CreateFrame("Text", "cnt", curFrame.abName)
			curFrame.cnt_c = UI.CreateFrame("Text", "cnt_c", curFrame.abName)
			curFrame.dmg = UI.CreateFrame("Text", "dmg", curFrame.abName)
			curFrame.dmg_n = UI.CreateFrame("Text", "dmg_n", curFrame.abName)
			curFrame.dmg_c = UI.CreateFrame("Text", "dmg_c", curFrame.abName)			

			if DamageCounter_Settings.icons[k] then
				curFrame.icon:SetTexture("Rift", DamageCounter_Settings.icons[k])
			else
				curFrame.icon:SetTexture("Rift", "Unknown")
			end
			curFrame.icon:SetVisible(true)
			curFrame.abName:SetVisible(false)

			DGC.abFrames[k] = curFrame
			
			abList[k] = nil
			if Inspect.System.Watchdog() < 0.05 then
--				print("frame creation yielding... Cnt = "..frcnt)
				coroutine.yield()
			end
		end
	end
	DGC.Header.abName:SetWidth(frWidth.a)
	abFrameOrderNeeded = true
	txtUpdateNeeded = true
--	print("E:frameUpdate()")
end

function DGC.setupUI()
	DGC.Title = UI.CreateFrame("Text", "DGC.Frame", DGC.Frame)
	DGC.Title:SetFontSize(14)
	DGC.Title:SetText(string.format("Damage Counter - Role #%d", (curRole or 0)))
	DGC.Title:SetPoint("BOTTOMCENTER", DGC.Frame, "TOPCENTER", 0,0)
	DGC.Title:SetLayer(1)
	ttlHeight = DGC.Title:GetHeight()
	DGC.TitleBG = UI.CreateFrame("Frame", "DGC.Frame", DGC.Frame)
	DGC.TitleBG:SetBackgroundColor(0,0,0,0.50)
	DGC.TitleBG:SetPoint("BOTTOMLEFT", DGC.Frame, "TOPLEFT", 0,0)
	DGC.TitleBG:SetHeight(ttlHeight)
	DGC.TitleBG:SetLayer(-1)
	function DGC.Title.Event:LeftDown()
		self.mouseDown = true
		local md = Inspect.Mouse()
		self.sx = md.x - DGC.Frame:GetLeft()
		self.sy = md.y - DGC.Frame:GetTop()
	end
	function DGC.Title.Event:MouseMove()
		if self.mouseDown then
			local nx, ny
			local md = Inspect.Mouse()
			nx = md.x - self.sx
			ny = md.y - self.sy
			DGC.Frame:SetPoint("TOPLEFT", UIParent, "TOPLEFT", nx, ny)
			DamageCounter_Settings.x = nx
			DamageCounter_Settings.y = ny
		end
	end
	function DGC.Title.Event:LeftUp()
		if self.mouseDown then
			self.mouseDown = false
		end
	end
	function DGC.Title.Event:RightClick()
		DamageCounter_Settings.roles[curRole] = { abilities = {}, count = 0, total = 0 }
		abList = {}
		abFrameOrderNeeded = true
	end
	DGC.Header = {}
	DGC.Header.abName = UI.CreateFrame("Text", "DGC.Header.abName", DGC.Frame)
	DGC.Header.abName:SetText("Ability")
	DGC.Header.abName:SetPoint("TOPLEFT", DGC.Frame, "TOPLEFT", 0,0)
	frWidth.a = DGC.Header.abName:GetWidth()
	DGC.Header.cnt = UI.CreateFrame("Text", "DGC.Header.cnt", DGC.Frame)
	DGC.Header.cnt:SetText("#")
	DGC.Header.cnt:SetPoint("TOPLEFT", DGC.Header.abName, "TOPRIGHT", 0,0)
	frWidth.c = DGC.Header.cnt:GetWidth()
	DGC.Header.cnt_c = UI.CreateFrame("Text", "DGC.Header.cnt", DGC.Frame)
	DGC.Header.cnt_c:SetText("#Crit")
	DGC.Header.cnt_c:SetPoint("TOPLEFT", DGC.Header.cnt, "TOPRIGHT", 0,0)
	frWidth.cc = DGC.Header.cnt_c:GetWidth()
	DGC.Header.dmg = UI.CreateFrame("Text", "DGC.Header.dmg", DGC.Frame)
	DGC.Header.dmg:SetText("Total")
	DGC.Header.dmg:SetPoint("TOPLEFT", DGC.Header.cnt_c, "TOPRIGHT", 0,0)
	frWidth.t = DGC.Header.dmg:GetWidth()
	DGC.Header.dmg_n = UI.CreateFrame("Text", "DGC.Header.dmg_n", DGC.Frame)
	DGC.Header.dmg_n:SetText("Damage")
	DGC.Header.dmg_n:SetPoint("TOPLEFT", DGC.Header.dmg, "TOPRIGHT", 0,0)
	frWidth.nd = DGC.Header.dmg_n:GetWidth()
	DGC.Header.dmg_c = UI.CreateFrame("Text", "DGC.Header.dmg_c", DGC.Frame)
	DGC.Header.dmg_c:SetText("CritDamage")
	DGC.Header.dmg_c:SetPoint("TOPLEFT", DGC.Header.dmg_n, "TOPRIGHT", 0,0)
	frWidth.cd = DGC.Header.dmg_c:GetWidth()
	hdrHeight = DGC.Header.abName:GetHeight()
	DGC.Frame:SetHeight(hdrHeight)

	DGC.Icon = UI.CreateFrame("Texture", "DGC.Icon", DGC.context)
	DGC.Icon:SetHeight(ttlHeight + hdrHeight)
	DGC.Icon:SetWidth(ttlHeight + hdrHeight)
	DGC.Icon:SetTexture("Rift", "Data/UI/ability_icons/flash1.dds")
	if DamageCounter_Settings.docked == "Y" then
		DGC.Icon:SetPoint("TOPRIGHT", DGC.TitleBG, "TOPLEFT", 0, 0)
	else
		DGC.Icon:SetPoint("TOPLEFT", UIParent, "TOPLEFT", DamageCounter_Settings.icon_x, DamageCounter_Settings.icon_y)
	end
	function DGC.Icon.Event:LeftDown()
		self.mouseLDown = true
		if DamageCounter_Settings.docked == "N" then
			local md = Inspect.Mouse()
			self.sx = md.x - DGC.Icon:GetLeft()
			self.sy = md.y - DGC.Icon:GetTop()
		end
	end
	function DGC.Icon.Event:MouseMove()
		if self.mouseLDown and DamageCounter_Settings.docked == "N" then
			local nx, ny
			local md = Inspect.Mouse()
			nx = md.x - self.sx
			ny = md.y - self.sy
			DGC.Icon:SetPoint("TOPLEFT", UIParent, "TOPLEFT", nx, ny)
			DamageCounter_Settings.icon_x = nx
			DamageCounter_Settings.icon_y = ny
		end
	end

	function DGC.Icon.Event:LeftUp()
		self.mouseLDown = false
	end

	function DGC.Icon.Event:RightClick()
		if self.mouseLDown then
			if DamageCounter_Settings.docked == "Y" then
				local nx, ny
				nx = DGC.Icon:GetLeft()
				ny = DGC.Icon:GetTop()
				DGC.Icon:ClearPoint("TOPRIGHT")
				DGC.Icon:SetPoint("TOPLEFT", UIParent, "TOPLEFT", nx, ny)
				DamageCounter_Settings.docked = "N"
				print("Icon undocked, and can be repositioned")
			else
				DGC.Icon:ClearPoint("TOPLEFT")
				DGC.Icon:SetPoint("TOPRIGHT", DGC.TitleBG, "TOPLEFT", 0, 0)
				DamageCounter_Settings.docked = "Y"
			end
		else
			_DGCVisible = not _DGCVisible
			DGC.Frame:SetVisible(_DGCVisible)
		end
	end
end

function DGC.SetText()
--	print("S:SetText()")
	local numTot = DamageCounter_Settings.roles[curRole].count or 1
	local dmgTot = DamageCounter_Settings.roles[curRole].total or 1
	local w
	local wchanged = false
	for k,_ in pairs(abTxtChanges) do
		local ab = DamageCounter_Settings.roles[curRole].abilities[k]
--		/script DamageCounter_Settings.roles = nil		
		if DGC.abFrames[k] == nil then
			abList[k] = true
			abFrameUpdateNeeded = true
		else
			DGC.abFrames[k].cnt:SetText(string.format("%d [%.2f%%]", ab.cnt, 100*(ab.cnt/numTot)))
			w = DGC.abFrames[k].cnt:GetWidth()
			if w > frWidth.c then 
				frWidth.c = w
				DGC.Header.cnt:SetWidth(w)
				wchanged = true
			end
			DGC.abFrames[k].cnt_c:SetText(string.format("%d [%.2f%%]", (ab.cntCrit or 0), 100*((ab.cntCrit or 0)/ab.cnt)))
			w = DGC.abFrames[k].cnt_c:GetWidth()
			if w > frWidth.cc then 
				frWidth.cc = w
				DGC.Header.cnt_c:SetWidth(w)
				wchanged = true
			end
			DGC.abFrames[k].dmg:SetText(string.format("%d [%.2f%%]", (ab.dmg or 0), 100*((ab.dmg or 0)/dmgTot)))
			w = DGC.abFrames[k].dmg:GetWidth()
			if w > frWidth.t then 
				frWidth.t = w
				DGC.Header.dmg:SetWidth(w)
				wchanged = true
			end
			DGC.abFrames[k].dmg_n:SetText(string.format("%d - %d", (ab.min_n or 0), (ab.max_n or 0)))
			w = DGC.abFrames[k].dmg_n:GetWidth()
			if w > frWidth.nd then 
				frWidth.nd = w
				DGC.Header.dmg_n:SetWidth(w)
				wchanged = true
			end
			DGC.abFrames[k].dmg_c:SetText(string.format("%d - %d", (ab.min_c or 0), (ab.max_c or 0)))
			w = DGC.abFrames[k].dmg_c:GetWidth()
			if w > frWidth.cd then 
				frWidth.cd = w
				DGC.Header.dmg_c:SetWidth(w)
				wchanged = true
			end
			abTxtChanges[k] = nil
			if visFrames[k] == nil then
				abFrameOrderNeeded = true
			end
		end
	end
	if wchanged then
		local totWidth = frWidth.a + frWidth.c + frWidth.cc + frWidth.t + frWidth.cd + frWidth.nd
		DGC.Frame:SetWidth(totWidth)
		DGC.Title:SetWidth(totWidth)
		DGC.TitleBG:SetWidth(totWidth)
	end
--	print("E:SetText()")
end

function DGC.abFrameOrder()
	local cnt=0
	local p
	local activeList = {}
--	print("S:abFrameOrder()")
	
	while(curRole == false) do
		coroutine.yield()
	end
	
	local brkOut = true
	
	while brkOut do
		local x = Inspect.System.Watchdog()
--		print(string.format("Time remaining: %f", x))
		if x < 0.05 then
--			print("Less than 0.05s - watchdog yielding")
			coroutine.yield()
		else
			brkOut = false
		end
	end

	for k,_ in pairs(DamageCounter_Settings.roles[curRole].abilities) do
		table.insert(activeList, k)
	end
	table.sort(activeList)
	for k,v in ipairs(activeList) do
		if DGC.abFrames[v] ~= nil then
			if cnt==0 then
				DGC.abFrames[v].abName:SetPoint("TOPLEFT", DGC.Header.abName, "BOTTOMLEFT", 0,0)
				DGC.abFrames[v].cnt:SetPoint("TOPLEFT", DGC.Header.cnt, "BOTTOMLEFT", 0,0)
				DGC.abFrames[v].cnt_c:SetPoint("TOPLEFT", DGC.Header.cnt_c, "BOTTOMLEFT", 0,0)
				DGC.abFrames[v].dmg:SetPoint("TOPLEFT", DGC.Header.dmg, "BOTTOMLEFT", 0,0)
				DGC.abFrames[v].dmg_n:SetPoint("TOPLEFT", DGC.Header.dmg_n, "BOTTOMLEFT", 0,0)
				DGC.abFrames[v].dmg_c:SetPoint("TOPLEFT", DGC.Header.dmg_c, "BOTTOMLEFT", 0,0)
			else
				DGC.abFrames[v].abName:SetPoint("TOPLEFT", DGC.abFrames[p].abName, "BOTTOMLEFT", 0,0)
				DGC.abFrames[v].cnt:SetPoint("TOPLEFT", DGC.abFrames[p].cnt, "BOTTOMLEFT", 0,0)
				DGC.abFrames[v].cnt_c:SetPoint("TOPLEFT", DGC.abFrames[p].cnt_c, "BOTTOMLEFT", 0,0)
				DGC.abFrames[v].dmg:SetPoint("TOPLEFT", DGC.abFrames[p].dmg, "BOTTOMLEFT", 0,0)
				DGC.abFrames[v].dmg_n:SetPoint("TOPLEFT", DGC.abFrames[p].dmg_n, "BOTTOMLEFT", 0,0)
				DGC.abFrames[v].dmg_c:SetPoint("TOPLEFT", DGC.abFrames[p].dmg_c, "BOTTOMLEFT", 0,0)
			end
			cnt=cnt+1
			DGC.abFrames[v].abName:SetVisible(true)
			visFrames[v] = true
			p=v
		end
	end
	
	for k,_ in pairs(visFrames) do
		if DamageCounter_Settings.roles[curRole].abilities[k] == nil then
			visFrames[k] = nil
			DGC.abFrames[k].abName:SetVisible(false)
		end
	end
--	print("E:abFrameOrder()")
end

function DGC.RoleChange(u)
--	print("Event: RoleChange")
	curRole = u
	roleUpdateNeeded = true
end

function DGC.RoleSetup()
	print(string.format("Role # changing to %s", tostring(curRole)))
	abTxtChanges = {}
	if not (DamageCounter_Settings.roles[curRole]) then
		DamageCounter_Settings.roles[curRole] = {}
		DamageCounter_Settings.roles[curRole].abilities = {}
		DamageCounter_Settings.roles[curRole].count = 0
		DamageCounter_Settings.roles[curRole].total = 0
	end
	for k,v in pairs(DamageCounter_Settings.roles[curRole].abilities) do
		abTxtChanges[k] = true
	end
	DGC.Title:SetText(string.format("Damage Counter - Role #%s", tostring(curRole)))
	abFrameOrderNeeded = true
	txtUpdateNeeded = true
end

function DGC.CombatDmg(i)
	if i.target == playerID then return end
	if (i.damage or 0) == 0 then return end
	
	if i.caster == playerID then
		local abName = i.abilityName or "UNKNOWN"
		local ct = Inspect.Time.Real()

		DamageCounter_Settings.roles[curRole].count = (DamageCounter_Settings.roles[curRole].count or 0) + 1
		DamageCounter_Settings.roles[curRole].total = (DamageCounter_Settings.roles[curRole].total or 0) + (i.damage or 0)
		if not (DamageCounter_Settings.roles[curRole].abilities[abName]) then
			DamageCounter_Settings.roles[curRole].abilities[abName] = {
				cnt = 0,
				cntCrit = 0,
				dmg = 0,
				min_n = 0,
				max_n = 0,
				min_c = 0,
				max_c = 0				
				}
			if not DamageCounter_Settings.icons[abName] then
				DamageCounter_Settings.icons[abName] = "Data/\\UI\\texture\\global\\placeholder_icon.dds"
				if i.ability or false then
					local adtl  = Inspect.Ability.Detail(i.ability)
					if adtl.icon then
						DamageCounter_Settings.icons[abName] = adtl.icon
					end
				end
			end
		end
		local ab = DamageCounter_Settings.roles[curRole].abilities[abName]
		ab.cnt = ab.cnt + 1
		ab.dmg = ab.dmg + (i.damage or 0)
		if (i.crit or false) then
			ab.cntCrit = ab.cntCrit+1
			if (ab.min_c == 0) or (ab.min_c > i.damage) then
				ab.min_c = i.damage
			end
			if (ab.max_c == 0) or (ab.max_c < i.damage) then
				ab.max_c = i.damage
			end
		else
			if (ab.min_n == 0) or (ab.min_n > i.damage) then
				ab.min_n = i.damage
			end
			if (ab.max_n == 0) or (ab.max_n < i.damage) then
				ab.max_n = i.damage
			end
		end
		abTxtChanges[abName] = true
		txtUpdateNeeded = true
	end
end
		
function DGC.UpdateHandler()
	local lu = 0
	while true do
		local cu = Inspect.Time.Real()
		if buildUINeeded then
			DGC.setupUI()
			buildUINeeded = false
		elseif abFrameUpdateNeeded then
			DGC.frameUpdate()
			abFrameUpdateNeeded = false
		elseif abFrameOrderNeeded then
			DGC.abFrameOrder()
			abFrameOrderNeeded = false
		elseif txtUpdateNeeded then
			if (cu-lu) > 0.1 then
				DGC.SetText()
				txtUpdateNeeded = false
				lu = cu
			end
		elseif roleUpdateNeeded then
			DGC.RoleSetup()
			roleUpdateNeeded = false
		end
		coroutine.yield()
	end
end

function DGC.OnUpdate()
	if coroDead then return end
	if tx_firstrun == 0 then
		tx_firstrun = 1
		DGC.coUpdateHandler = coroutine.create(DGC.UpdateHandler)
	elseif role_needed then
		curRole = Inspect.TEMPORARY.Role() or false
		if curRole then
			role_needed = false
			roleUpdateNeeded = true
			--txtUpdateNeeded = true
		end
	end
	local ok, errormsg = coroutine.resume(DGC.coUpdateHandler)
	if not ok then
		coroDead = true
		error("Error in coroutine: "..errormsg)
	end
end

---------------------
-- Register Events
---------------------

table.insert(Event.Addon.Load.End, {DGC.AddonLoaded, "DamageCounter", "Event.Addon.Load.End"})
table.insert(Event.Addon.SavedVariables.Load.End, {DGC.SVLoaded, "DamageCounter", "Event.Addon.SavedVariables.Load.End" })
table.insert(Event.TEMPORARY.Role, { DGC.RoleChange, "DamageCounter", "Event.TEMPORARY.Role"})
table.insert(Event.System.Update.Begin, { DGC.OnUpdate, "DamageCounter", "Event.System.Update.Begin"})
